/* Very simple driver to support IPC between applications.  Each application opens    the driver (to be sure that its open) and then makes one control call to register   itself with a unique application number and a desired buffer size.   When an application wants to talk to another application, it makes a status   call with the number of the application and gets back the address of that   application's buffer.  It can then communicate by putting a message   directly into the buffer.  By convention, the first two bytes of the buffer   hold a count of the number of characters currently in the buffer, the next   two bytes hold the maximum size of the buffer and the format of the remainder   of the buffer should be agreed upon by the applications.  The supplied 'C'   routines support multiple messages in the buffer by making the first two bytes   of each message a message length word. */#define NUM_APPS	2struct {	int appNumber;	int *buffer;	} appBuffers[NUM_APPS];Boolean alreadyOpened = FALSE;main(cntrlParam *paramBlock, DCtlPtr devCtlEnt, int n){	int i;	THz zone;	Handle h;		switch(n) {	  case 0:		/* Open */	  	if (alreadyOpened)	  		return(noErr);	  				if (devCtlEnt->dCtlStorage == 0)			return(openErr);  		alreadyOpened = TRUE;  		  		SysBeep(60);	/* Let's you know it's been loaded */  		  		/* Before doing anything else, lock the driver in place and detach its  		   resource. This is necessary so that the driver can survive after the  		   application that created it has exitted.  Unfortunately, this leaves it  		   in memory until the next reboot, but its not that large anyway.  */  		HLock(devCtlEnt->dCtlDriver);  		DetachResource(devCtlEnt->dCtlDriver);  		/* Initialize the application registration array */		for (i = 0; i < NUM_APPS; i++) {			appBuffers[i].appNumber = -1;			appBuffers[i].buffer = 0L;			}		return(noErr);	  case 1:		/* Prime */				break;	  case 2:		/* Control */	  	switch(paramBlock->csCode) {	  	  case 1:		/* Register an application */	  	  	/* Make sure it doesn't already exist */	  		for (i = 0; i < NUM_APPS && appBuffers[i].appNumber != *(paramBlock->csParam); i++);	  			  		/* Already exists, if requesting a different size buffer, return failure */	  		if (i != NUM_APPS) {	  			if (*(appBuffers[i].buffer + 1) != *(paramBlock->csParam + 1))	  				return(controlErr);	  			else	  				return(noErr);	  			}	  		/* Find a free slot */	  		for (i = 0; i < NUM_APPS && appBuffers[i].appNumber != -1; i++);	  			  		/* If no more slots available, return failure */	  		if (i == NUM_APPS)	  			return(controlErr);	  			  		/* Record it in the table and allocate memory for it */	  		zone = GetZone();	  		SetZone(SystemZone());	  		if ((h = NewHandle(*(paramBlock->csParam + 1))) == 0L) {	  			SetZone(zone);	  			return(controlErr);	  			}	  		MoveHHi(h);	  		HLock(h);	  		appBuffers[i].buffer = *(int **)h;	  		SetZone(zone);	  			  		appBuffers[i].appNumber = *(paramBlock->csParam);	  			  		*(appBuffers[i].buffer) = 0;	  		*(appBuffers[i].buffer + 1) = *(paramBlock->csParam + 1);	  			  		return(noErr);	  			  	  case 2:		/* Unregister an application */	  		/* Find the application */	  		for (i = 0; i < NUM_APPS && appBuffers[i].appNumber != *(paramBlock->csParam); i++);	  			  		/* Couldn't find it, return failure */	  		if (i == NUM_APPS)	  			return(controlErr);	  			  		zone = GetZone();	  		SetZone(SystemZone());	  		h = RecoverHandle(appBuffers[i].buffer);	  		DisposHandle(h);	  		SetZone(zone);	  		appBuffers[i].buffer = 0L;	  		appBuffers[i].appNumber = -1;	  			  		return(noErr);	  	  default:	  	  	return(controlErr);	  		}	  case 3:		/* Status */	  		/* Find the application */	  		for (i = 0; i < NUM_APPS && appBuffers[i].appNumber != paramBlock->csCode; i++);	  			  		/* Couldn't find it, return failure */	  		if (i == NUM_APPS) {	  			*((void **)(paramBlock->csParam)) = 0L;	  			return(statusErr);	  			}	  			  		*((int **)(paramBlock->csParam)) = appBuffers[i].buffer;	  		return(noErr);	  case 4:		/* Close */	    		zone = GetZone();  		SetZone(SystemZone());  			  	for (i = 0; i < NUM_APPS; i++)	  		if (appBuffers[i].appNumber != -1) {	  			h = RecoverHandle(appBuffers[i].buffer);	  			DisposHandle(h);	  			}	  	SetZone(zone);		return(noErr);	default:		break;		}	return(openErr);}